#pragma once

#include <boost/asio.hpp>



class message
{
protected:
    virtual std::string get_message_length() = 0;
    virtual std::string get_message() = 0;
    virtual void process_data(std::string&) = 0;

public:

    void send(boost::asio::ip::tcp::socket&);
    void receive(boost::asio::ip::tcp::socket&);

    virtual ~message();
};
